import abc
from .const import DOMAIN as DOMAIN
from .utils import BondDevice as BondDevice, BondHub as BondHub
from bond_api import BPUPSubscriptions as BPUPSubscriptions
from homeassistant.const import ATTR_NAME as ATTR_NAME
from homeassistant.core import callback as callback
from homeassistant.helpers.entity import Entity as Entity
from homeassistant.helpers.event import async_track_time_interval as async_track_time_interval
from typing import Any

class BondEntity(Entity, metaclass=abc.ABCMeta):
    def __init__(self, hub: BondHub, device: BondDevice, bpup_subs: BPUPSubscriptions, sub_device: Union[str, None]=...) -> None: ...
    @property
    def unique_id(self) -> Union[str, None]: ...
    @property
    def name(self) -> Union[str, None]: ...
    @property
    def should_poll(self) -> bool: ...
    @property
    def device_info(self) -> Union[dict[str, Any], None]: ...
    @property
    def assumed_state(self) -> bool: ...
    @property
    def available(self) -> bool: ...
    async def async_update(self) -> None: ...
    async def async_added_to_hass(self) -> None: ...
    async def async_will_remove_from_hass(self) -> None: ...
